% New article: mdpi-Processes
% Special Issue:
% The script simulates the closed-loop's working using the ML models.
% The control outputs are using the coefficients of the ML models.
load('WS_Modelsw','MODELSW','DATAKTest','DATAKTrain');
load('WSKOEF','KOEF');
[V,m0,K3]=InitConst();
% Limits of the control variable 
umin=50.;
umax=2000.0;
H=120;
tic
X00=[0.36 0]; %Initial state
uML=zeros(1,H);
state2=zeros(H+1,2); 

X0=X00;
state2(1,:)=X0;

for k=1:H
    %Compute the control outputusing the ML model
    uML(k)=KOEF(k,1)+KOEF(k,2)*X0(1)+KOEF(k,3)*X0(2);
    
    fprintf('k= %3d  x1=%7.4f x2=%7.4f uML=%9.4f \n',...
        k,X0(1),X0(2),uML(k));
    
    %Apply the control bounds
    if uML(k)>umax
     uML(k)=umax;
    end
    if uML(k)<umin
 axi    uML(k)=umin;
    end
    % The light applied to the PBR is the control value
    q0=uML(k);
    disp(X0);
    X01=INV_RealProcessStep(q0,X0(1),k); %the next x1 value
    
    X02=X0(2)+K3*uML(k); %the next x2 value
    X0=[X01 X02];        %the next state
    fprintf('           X01=%7.4f X02=%7.4f\n',X01,X02);
  
    state2(k+1,:)=X0;
end
disp('#######################################################');
u_vector=uML;
staref=state2(H+1,:);
disp('final state:');
disp(staref);

IndF=H+1;
LUM=K3*sum(u_vector);
mprod=V*(state2(IndF,1)-X00(1));
JML= 10*(mprod-m0)+LUM; 

str=sprintf('&&&  x00=%7.4f yield mass=%7.4f  Light=%7.4f  Perf Index=%7.4f',...
    X00(1),mprod,LUM,JML);
disp(str);
toc
DRAWfig_MLSW;
