% New article: mdpi-Processes
% Special Issue:Industrial Process Operation State Sensing and Performance Optimization
% The script simulates the closed-loop's working using the ML models.
% The control outputs are using the coefficients of the ML models.
load('WS_ModelsRNN','MODELNN','DATAKTest','DATAKTrain');
[V,m0,K3]=InitConst();
% Limits of the control variable 
umin=50.;
umax=2000.0;
H=120;

X00=[0.36 0]; %Initial state;   IT IS A 1x2 VECTOR
uML=zeros(1,H);
state2=zeros(H+1,2); 

X0=X00;  %IT IS A 1x2 VECTOR
state2(1,:)=X0;
% k+1; k=0 becomes kplus1=1.

tic
for kplus1=1:H
    %Compute the control outputusing the ML model
    mdlNN=MODELNN{kplus1};
    if (kplus1==1)
     sT=array2table(X00(1),'VariableNames',{'x1'});
    else
      sT=array2table(X0,'VariableNames',{'x1','x2'});
    end
    uML(kplus1)=mdlNN.predictFcn(sT);
    
    fprintf('kplus1= %3d  x1=%7.4f x2=%7.4f uML=%9.4f \n',...
        kplus1,X0(1),X0(2),uML(kplus1));
    
    %Apply the control bounds
    if uML(kplus1)>umax
     uML(kplus1)=umax;
    end
    if uML(kplus1)<umin
     uML(kplus1)=umin;
    end
    
    % The light applied to the PBR is the control value
    q0=uML(kplus1);
    %disp(X0);
    X01=INV_RealProcessStep(q0,X0(1),kplus1); %the next x1 value
    
    X02=X0(2)+K3*uML(kplus1); %the next x2 value
    X0=[X01 X02];        %the next state
    fprintf('  Next state:         X01=%7.4f X02=%7.4f\n\n',X01,X02);
  
    state2(kplus1+1,:)=X0;
end
toc
disp('#######################################################');
u_vector=uML;
staref=state2(H+1,:);
disp('final state:');
disp(staref);

IndF=H+1;
LUM=K3*sum(u_vector);
mprod=V*(state2(IndF,1)-X00(1));
JML= 10*(mprod-m0)+LUM; 

str=sprintf('&&&  x00=%7.4f yield mass=%7.4f  Light=%7.4f  Perf Index=%7.4f',...
    X00(1),mprod,LUM,JML);
disp(str);

DRAWfig_MLNN;
