%DRAWfigWithoutCR.m displays Fig 5a si 5b after the average computation
load('WSPwithoutCR_i0','i0','xxMuRHC','xxMstare','xxJ','xxmprod',...
    'xxLUM','xxNAp','uRHC','stare','x00','m0');
disp('A typical evolution\n');
INIT_CONST;
t_fin=120;
LIGHTv=zeros(1,t_fin); 
u_vector=uRHC;
t_vector=0:1:t_fin;

IndF=length(t_vector);
LUM=K3*sum(u_vector);
mprod=V*(stare(IndF)-x00);
J= 10*(mprod-m0)+LUM; 
NapelAvg=xxNAp(i0);
fprintf('\n\n Final values for Overall integration using uRHC\n');
fprintf('&&&  yield mass=%7.4f  Light=%7.4f  Perf Index=%7.4f \n\n ',...
    mprod,LUM, J);

%Light amount
LIGHTv(1)=uRHC(1);
for i=2:t_fin
    LIGHTv(i)=LIGHTv(i-1)+uRHC(i);
end
Lumv1=[0 K3*LIGHTv]; %Put 0 as first element
mass=V*(stare-x00);

figure(51) % (a)
stairs(t_vector,[uRHC uRHC(120)],'r');
xlabel('time [h]');
ylabel('quasi-optimal light intensity ');
axis([0,120,300,1100]);
grid MINOR;
%text(3.2,2,strcat('Q_{0}=',num2str(Q0)),'FontSize',14);
text(20.,900.,'\it{control output}','FontSize',12);
text(20.,1050,'Closed-loop without control ranges','FontSize',12);

figure(52)
plot(t_vector,stare,'r',t_vector,Lumv1/2,'b',t_vector,mass,'k',[0 120],[3 3],'--k');
axis([0,120,0,5.]);
xlabel('time [h]');
ylabel('state variables');
legend('\it{x}_{1}','\it{x}_{2}','\Deltam','location','NorthWest'); %,'position',[100 180 100 120];
% text(10.,190.,'\it{H}=20','FontSize',12);
% text(10.,170,'open-loop','FontSize',12);
grid MINOR;
text(40.,4.75,'Process evolution','FontSize',12);
text(30.,2.75,'m_{0}','FontSize',12);
text(70.,3.5,'0.5\cdot\it{x}_2','FontSize',12);
text(70.,1.,'\Deltam(120)\geq{m}_{0}','FontSize',12);
