% New article: mdpi-Processes
% Special Issue: Construction of Step Wise models using dataset for each sampling period-k
% and control loop simulation using the regression models.

% The work spaces are protected. If you want to activate the 
% saving instructions, erase the character %.
% The models saved in 'WS_Modelsw.mat' will be used by the script
% "CONTROL_loopML" to simulate the closed-loop's working using these ML models.

load('WS_Modelsv1','MODEL','DATAKTest','DATAKTrain');
MODELSW=cell(120,1); % Cell array for the step wise models
%loop for all sampling period-k in [0, H]
H=120;
KOEF=zeros(H,3);  %C0=KOEF(k,1);C1=KOEF(k,2);C0=KOEF(k,3);
ListX2=[11,16,21,60,65,69,84,94,95,100,104,105,108,111,115,119];
tic
for kplus1=1:H
disp('********************************************')
fprintf('\n\n                                                       &&&&kp1=%2d\n',kplus1);
datakTrain=DATAKTrain{kplus1};
datakTest=DATAKTest{kplus1};
%T=union(datakTest,datakTrain,'stable'); % T contains the data set

mdlsw=stepwiselm(datakTrain);
disp(mdlsw);
MODELSW{kplus1}=mdlsw;
%Complete the matrix KOEF
coef=mdlsw.Coefficients.Estimate;
nc=length(coef);
KOEF(kplus1,1)=coef(1);
if (nc==2)
    KOEF(kplus1,2)=coef(2);
end
end
disp(KOEF);
disp('&&&&&&&&&&&&&&&&&&&&&*****************');
%Correction of coefficients' placement
nl=length(ListX2);
for i=1:nl
   poz=ListX2(i);
   KOEF(poz,3)=KOEF(poz,2);
   KOEF(poz,2)=0.;
end
indx=1:H;
KOEF1=[indx' KOEF];
disp(KOEF1);
disp('&&&&&&&&&&&&&&&&&&&&&*****************');

% Save models in a new Work Space
%save('WS_Modelsw','MODELSW','DATAKTest','DATAKTrain');
%save('WSKOEF','KOEF')
%ComparisonSW;
toc
