function [V,m0,K3]=InitConst()
global mumax Ki Kii mus;
global kz
global KGz

A = 0.0375; % PBR lighted area [m2]
V = 1.45;   % PBR volume [L]
L = 0.04;   % PBR depth [m]
Ea = 172;   % mass absorption coefficient [m2/kg]
Es = 870;   % mass scattering coefficient [m2/kg]
b = 0.0008; % backward scattering fraction [-]
mumax=0.16; % maximum specific growth rate [h-1]
Ki=120;     % irradiance half-saturation constant [µmol/m2/s]
Kii = 2500; % irradiance inhibition constant [µmol/m2/s]
mus=0.013;  % maintenance rate [h-1]
alpha = (Ea/(Ea+2*b*Es))^(1/2);
z = linspace(0,L,100);
kz=length(z);
KGz=zeros(1,100);
for i=1:kz
 KGz(i) = exp(-(1+alpha)/2/alpha*Ea*z(i));    % Irradiance (light inside the culture) (umol/m2/s)
end
K3=A*3600/1e6;
m0=3.;
end